﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 

	#FullScreen: False
	#IncludeTitle: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private XUI As XUI

	Type ItemValue (rtnReceiptID As String)
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
		
	'v0.1  (17/05/2020) - Initial development
	Private strVersion As String = "v0.1"
	Private lblVersion As Label

	Private clvPanel As CustomListView
	
	Private lblReceiptID As Label
	Private lblReceiptDate As Label
	Private lblRetailerName As Label
	Private lblReceiptAmount As Label
	Private lblStoreChargeID As Label
	Private lblReceiptClaimID As Label
	Private lblReceiptNotes As Label
	Private imgPhoto As ImageView
	
	Private ECReceiptSet As ResultSet

	Private outReceiptID As String
	Private outReceiptDate As String
	Private outRetailerName As String
	Private outReceiptAmount As String
	Private outStoreChargeID As String
	Private outReceiptClaimID As String
	Private outReceiptNotes As String
	Private outReceiptPhoto As InputStream
	
	Private intReceiptRetailerID As Int
	Private strReceiptDate As String
	Private intReceiptAmount As Int
	Private dblReceiptAmount As Double
	
	Dim bytes() As Byte
	Dim bmp As Bitmap
	
	Private lblBack As Label
		
	Private strSQLQuery As String
	
	Private strNothing As String = ""
		
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("ECS20")
	
	lblVersion.Text = strVersion
	
End Sub

Sub Activity_Resume
	
	clvPanel.Clear
	
	SelectReceiptList
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub CreateItem(ReceiptID As String, ReceiptDate As String, RetailerName As String, _
							 ReceiptAmount As String, StoreChargeID As String, ReceiptClaimID As String, _
							 ReceiptNotes As String, ReceiptPhoto As InputStream) As B4XView

	Dim p As B4XView = XUI.CreatePanel("")
	
	p.SetLayoutAnimated(0, 0, 0, 100%x, 153dip)
	p.LoadLayout("ECS20clv")
	
	lblReceiptID.Text = ReceiptID
	lblReceiptDate.Text = ReceiptDate
	lblRetailerName.Text = RetailerName
	lblReceiptAmount.Text = ReceiptAmount
	lblStoreChargeID.Text = StoreChargeID
	lblReceiptClaimID.Text = ReceiptClaimID
	lblReceiptNotes.Text = ReceiptNotes
	imgPhoto.SetBackgroundImage(bmp.Rotate(90))
	Return p
	
End Sub

'SELECT DATABASE CALLS
'=====================

Sub SelectReceiptList
	DateTime.DateFormat = "hh:mm:ss"

	strSQLQuery = "Select * FROM Receipt ORDER BY ReceiptID DESC"
	
	ECReceiptSet = ECS00.SQLEC.ExecQuery(strSQLQuery)
	Log ("Start " & DateTime.Now)
	Do While ECReceiptSet.NextRow
		outReceiptID = ECReceiptSet.GetString("ReceiptID")
		strReceiptDate = ECReceiptSet.GetString("ReceiptDate")
		outReceiptDate = strReceiptDate.SubString2(4, 6) & "/" & strReceiptDate.SubString2(2, 4)
		outReceiptDate = outReceiptDate & "/" & strReceiptDate.SubString2(0, 2)
		intReceiptRetailerID = ECReceiptSet.GetString("ReceiptRetailerID")
		SelectRetailerName
		dblReceiptAmount = ECReceiptSet.GetDouble("ReceiptAmount")
		intReceiptAmount = dblReceiptAmount
		If dblReceiptAmount = intReceiptAmount Then
			outReceiptAmount = dblReceiptAmount & ".00"
		Else
			outReceiptAmount = dblReceiptAmount
		End If
		If outReceiptAmount.CharAt(outReceiptAmount.Length - 2) = "." Then
			outReceiptAmount = outReceiptAmount & "0"
		End If
		outReceiptAmount = "£" & outReceiptAmount
		outStoreChargeID = ECReceiptSet.GetString("ReceiptChargeStoreID")
		outReceiptNotes = ECReceiptSet.GetString("ReceiptNotes")
		bytes = ECReceiptSet.GetBlob("ReceiptPhoto")
		outReceiptPhoto.InitializeFromBytesArray(bytes, 0, bytes.Length)
		bmp.Initialize2(outReceiptPhoto)
		outReceiptClaimID = ECReceiptSet.GetInt("ReceiptClaimID")
		If outReceiptClaimID = "0" Then
			outReceiptClaimID = strNothing
		Else
			outReceiptClaimID = outReceiptClaimID & "." & ECReceiptSet.GetInt("ReceiptClaimPart")
		End If
		clvPanel.Add(CreateItem(outReceiptID, outReceiptDate, outRetailerName, outReceiptAmount, _
														outStoreChargeID, outReceiptClaimID, outReceiptNotes, _
														outReceiptPhoto), outReceiptID)
	Loop
	Log ("End " & DateTime.Now)
End Sub

Sub SelectRetailerName
		
	strSQLQuery = "Select RetailerName FROM Retailer WHERE RetailerID = ?"
	
	outRetailerName = ECS00.SQLEC.ExecQuerySingleResult2(strSQLQuery, _
		Array As String(intReceiptRetailerID))
	
End Sub

'CLICK EVENTS
'============

Sub lblBack_Click
	
	Activity.Finish

End Sub
